#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "dSFMT.h"

#define M 3			//the initial number of nodes
#define N 1000		//the total number of nodes

int main()
{

	int *ll,*lr;	//to write
	int *deg;
	int *cdf;
	
	int i;
	int select;
	int point=1;
	int rnd;
	
	dsfmt_t dsfmt1;
	dsfmt_init_gen_rand(&dsfmt1,200);
	
	ll=(int *)calloc(N+1,sizeof(int));
	lr=(int *)calloc(N+1,sizeof(int));
	deg=(int *)calloc(N+1,sizeof(int));
	cdf=(int *)calloc(N+1,sizeof(int));
	*(cdf+0)=0;
	for(point=1;point<M;point++)
	{
		*(ll+point)=point;
		*(lr+point)=point+1;
		*(deg+point)=2;
		*(cdf+point)=*(deg+point)+*(cdf+point-1);
	}
	
	*(ll+point)=point;
	*(lr+point)=1;
	*(deg+point)=2;
	*(cdf+point)=*(deg+point)+*(cdf+point-1);
	
		
	for(point=M+1;point<N+1;point++)
	{
		select=0;
		
		///the procedure using probability
		
		rnd=(*(cdf+point-1)-1)*dsfmt_genrand_close_open(&dsfmt1)+1;
		
		for(i=point-1;i>0;i--)
		{
		if( *(cdf+i)>=rnd && rnd>*(cdf+i-1))
			{
				select=i;
				break;
			}
		}
		///update
		*(ll+point)=point;
		*(lr+point)=select;
		*(deg+point)=1;
		*(deg+select)+=1;
		for(i=1;i<point+1;i++)
		{
		*(cdf+i)=*(deg+i)+*(cdf+i-1);
		}
	}
	
	for(i=1;i<N+1;i++)
	{
		printf("%d %d %d %d\n",*(ll+i),*(lr+i),*(deg+i),*(cdf+i));
	}
	
	
	free(ll);
	free(lr);
	free(deg);
	free(cdf);

}